    import java.applet.*;
    import java.awt.*;
    import java.awt.event.*;
    import java.lang.Math;

    public class LegTest extends Applet
       implements MouseListener, MouseMotionListener {
    	
       int mx, my;
       boolean isMouseDraggingBox = false;

       double width, height;
       
       double x1, y1;
       
       int xOfs, yOfs;
       
       double w;
       
       double v1, v2;
       
       public void init() {
          width = 50;
          height = 100;
          
          xOfs = 200;
          yOfs = 200;
          
          x1 = 100;
          y1 = 0;
          
          addMouseListener( this );
          addMouseMotionListener( this );
       }

       public void mouseEntered( MouseEvent e ) { }
       public void mouseExited( MouseEvent e ) { }
       public void mouseClicked( MouseEvent e ) { }
       public void mousePressed( MouseEvent e ) {
          mx = e.getX() - xOfs;
          my = e.getY() - yOfs;
          if ( width < mx+10 && mx < width+10 && height < my+10 && my < height+10 ) {
             isMouseDraggingBox = true;
          }
          e.consume();
       }
       public void mouseReleased( MouseEvent e ) {
          isMouseDraggingBox = false;
          e.consume();
       }
       public void mouseMoved( MouseEvent e ) { }
       public void mouseDragged( MouseEvent e ) {
          if ( isMouseDraggingBox ) {
             int new_mx = e.getX() - xOfs;
             int new_my = e.getY() - yOfs;
             
             if (new_my + yOfs > 0 & new_my + yOfs < 400 & new_mx + xOfs > 0 & new_mx + xOfs < 400) {
            	 width += new_mx - mx;
            	 height += new_my - my;
            	 
            	 mx = new_mx;
            	 my = new_my;
             }

             repaint();
             e.consume();
          }
       }

       public void paint( Graphics g ) {
          w = Math.sqrt(Math.pow(width, 2) + Math.pow(height, 2));
          
          if ((w <= 200) & (w > 20) ) {
        	  if (width >= 0) {
        		  v1 = Math.acos(height / w) + Math.acos(w / 200);
        	  }
        	  else {
        		  v1 = -Math.acos(height / w) + Math.acos(w / 200);
        	  }
        	  
        	  v2 = Math.asin(w / 200) * 2;
        	  
        	  x1 = Math.cos(v1 - (Math.PI / 2)) * 100.0;
        	  y1 = -Math.sin(v1 - (Math.PI / 2)) * 100.0;
        	  
        	  g.setColor( Color.green );
          }
          else {
        	  v1 = java.lang.Double.NaN;
        	  v2 = java.lang.Double.NaN;
        	  
        	  g.setColor( Color.red );
          }
          
          g.drawLine( (int)(xOfs),      (int)(yOfs),      (int)(xOfs + x1),    (int)(yOfs + y1)     );
          g.drawLine( (int)(xOfs + x1), (int)(yOfs + y1), (int)(xOfs + width), (int)(yOfs + height) );
          g.drawOval((int)(xOfs + width) - 10, (int)(yOfs + height) - 10, 20, 20);
          g.drawOval((int)(xOfs + x1) - 10, (int)(yOfs + y1) - 10, 20, 20);
          g.drawOval((int)(xOfs) - 10, (int)(yOfs) - 10, 20, 20);
          
          g.setColor( Color.black );
          g.drawString( "V1: " + Math.toDegrees(v1) + " deg.", 20, 20 );
          g.drawString( "V2: " + Math.toDegrees(v2) + " deg.", 20, 40 );
          g.drawString( "V1", xOfs, yOfs - 10 );
          g.drawString( "V2", (int)(xOfs + x1), (int)(yOfs + y1 - 10) );
       }
    }